<control-google-map>

	<div class="input-group">
		<input type="text" class="form-control" data-ref="lat_lng" value="{ state.lat_lng }" placeholder="συντεταγμένες χάρτη" onchange="{ input_change }">
		<span class="input-group-btn">
			<button class="btn btn-primary" title="Άνοιγμα χάρτη" onclick="{ show_map }"><i class="fa fa-map"></i></button>
		</span>
	</div>

	<div class="popup-ovelray" id="popup-map" style="display:none">
		<div class="popup-window popup-map">
			<div class="popup-heading">
                <div class="title">Χάρτης Google</div>
                <a href="#" class="close" onclick="{ close_map }">&times;</a>
            </div>

			<div class="popup-body">

				<div class="form-group mrg-bottom-none">
					<input type="text" class="form-control" data-ref="map_search" id="origin-input" placeholder="γράψτε περιοχή ή διεύθυνση">

					<div id="infowindow-content">
						<img src="" width="16" height="16" id="place-icon">
						<span id="place-name"  class="title"></span><br>
						<span id="place-address"></span>
					</div>

				</div>
				<hr class="mrg-top-none">
				<div class="map-canvas" id="map-canvas"></div>
				<div class="text-right">
					<a href="#" class="btn btn-primary" onclick="{ map_done }">ΕΠΙΛΟΓΗ ΣΗΜΕΙΟΥ</a>
					<a href="#" class="btn btn-default" onclick="{ close_map }">ΑΚΥΡΩΣΗ</a>
				</div>

			</div>

		</div> <!-- /popup-window -->
	</div> <!-- /popup-ovelray -->

	<script>
		/*
			Methods:
			set_lat_lng ( lat_lng string )

			Events:
			onchangehandler( lat_lng )
		*/

		this.state = {
			marker: null,
			initialized: false,
		}


		this.set_lat_lng = lat_lng => {
			this.state.lat_lng = lat_lng;
			this.update();
		}


		this.show_map = () => {
			$('#popup-map').show();

			if (!this.state.initialized) {
				this.init_map();
				this.state.initialized = true;
			}
		}

		this.close_map  = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			$('#popup-map').hide();
		}


		this.init_map = () => {
			var tag = this;

			var map_lat = 35.2967133;
			var map_lng = 24.8819445;
			var map_zoom = 9;
			var show_marker = false;

			if (this.state.lat_lng) {
				var arr = this.state.lat_lng.split(",");
				if (arr.length == 2) {
					var map_lat = parseFloat(arr[0]);
					var map_lng = parseFloat(arr[1]);
					var map_zoom = 13;
					show_marker = true;
				}
			}

			var origin_place_id = null;
            var travel_mode = google.maps.TravelMode.DRIVING;
            var map = new google.maps.Map(document.getElementById('map-canvas'), {
                mapTypeControl: true,
                scrollwheel: true,
                center: {lat: map_lat, lng: map_lng},
                zoom: map_zoom
            });

            if (show_marker) {
            	tag.state.marker = new google.maps.Marker({
	            	map: map,
	            	draggable:true,
					animation: google.maps.Animation.DROP,
					position: map.getCenter()
				});

	            // tag.state.marker = new google.maps.Marker({
	            // 	map: map,
	            // 	anchorPoint: new google.maps.Point(0, -29)
	            // });
	        }


            var input = document.getElementById('origin-input');
            var autocomplete = new google.maps.places.Autocomplete(input);

            // Bind the map's bounds (viewport) property to the autocomplete object,
            // so that the autocomplete requests use the current map bounds for the
            // bounds option in the request.
            autocomplete.bindTo('bounds', map);

            // Set the data fields to return when the user selects a place.
            autocomplete.setFields(['address_components', 'geometry', 'icon', 'name']);

            // var infowindow = new google.maps.InfoWindow();
            // var infowindowContent = document.getElementById('infowindow-content');
            // infowindow.setContent(infowindowContent);

            // var marker = new google.maps.Marker({
            // 	map: map,
            // 	anchorPoint: new google.maps.Point(0, -29)
            // });

            autocomplete.addListener('place_changed', function() {

            	// infowindow.close();
            	if (tag.state.marker) {
            		tag.state.marker.setVisible(false);
            	}

            	var place = autocomplete.getPlace();
            	if (!place.geometry) {
            		// User entered the name of a Place that was not suggested and
            		// pressed the Enter key, or the Place Details request failed.
            		window.alert("No details available for input: '" + place.name + "'");
            		return;
            	}

            	// If the place has a geometry, then present it on a map.
            	if (place.geometry.viewport) {
            		map.fitBounds(place.geometry.viewport);
            	} else {
            		map.setCenter(place.geometry.location);
            		map.setZoom(17);  // Why 17? Because it looks good.
            	}

				if (!tag.state.marker) {
					tag.state.marker = new google.maps.Marker({
						map: map,
						draggable:true,
						animation: google.maps.Animation.DROP,
						anchorPoint: new google.maps.Point(0, -29)
					});
				}

            	tag.state.marker.setPosition(place.geometry.location);
            	tag.state.marker.setVisible(true);


            	var address = '';
            	if (place.address_components) {
            		address = [
            			(place.address_components[0] && place.address_components[0].short_name || ''),
            			(place.address_components[1] && place.address_components[1].short_name || ''),
            			(place.address_components[2] && place.address_components[2].short_name || '')
            		].join(' ');
            	}

            	// infowindowContent.children['place-icon'].src = place.icon;
            	// infowindowContent.children['place-name'].textContent = place.name;
            	// infowindowContent.children['place-address'].textContent = address;
            	// infowindow.open(map, marker);
            });

        }


        this.input_change = event => {
			this.state.lat_lng = event.target.value;
			if (this.opts.onchangehandler) {
				this.opts.onchangehandler(this.state.lat_lng);
			}
		}


        this.map_done = event => {
        	event.preventDefault();

        	if (this.state.marker) {

        		this.state.lat_lng = this.state.marker.position.lat() + "," + this.state.marker.position.lng();

	        	if (this.state.marker && this.opts.onchangehandler) {
	        		this.opts.onchangehandler(this.state.lat_lng);
	        	}

	        	this.close_map();
	        } else {
	        	alert("Δεν έχετε επιλέξει σημείο στον χάρτη!");
	        }
        }

        // this.on("mount", function() {
        //   	//this.init_map();
        // });
	</script>
</control-google-map>